#!/usr/local/bin/perl

require "gb.cfg";
# require "cookie.lib";

$w2long = 0;

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
  ($name, $value) = split(/=/, $pair);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $value =~ s/\|//g;
  
  
  @words =  split(/\ /, $value);
  
  if ($allow_html == 0) {$value =~ s/<([^>]|\n)*>//g;}
  if ($allow_html == 1) {$value =~ s/</\&lt\;/g;}
  
  $FORM{$name} = $value;
  
  foreach $word (@words)
  {
    $word_len = length ($word);
    if ($word_len > $max_word_size) {$w2long = 1;}
  }
}


# Define date/time...

@test = localtime (time);
#$c_month = $months[$test[4]];
$c_month = $test[4];
$c_hour = $test[2];
if ($test[2] < 10) {$c_hour = "0$test[2]";}
$c_min = $test[1];

$c_year = 1900+$test[5];

$c_day = $test[3];


require "html.cfg";


$rec_len = length ($FORM{'comments'});

if ($max_record_size > 0)
{
 &too_long unless $rec_len < $max_record_size;
}

&no_name unless $FORM{'realname'};
&no_comments unless $FORM{'comments'};

# Begin the Editing of the Guestbook File

$FORM{'comments'} =~ s/\cM\n/<BR>/g;

if ($w2long == 1) {&too_long_words;}


if ($FORM{'username'}) 
{
($part1, $part2) = split(/\@/, $FORM{'username'});
($part3, $part4) = split(/\./, $part2);

if ($part1 eq "") {&wrong_mail;}
if ($part2 eq "") {&wrong_mail;}
if ($part3 eq "") {&wrong_mail;}
if ($part4 eq "") {&wrong_mail;}

if ($FORM{'username'} =~ /[\x80-\xff]/i) {&wrong_mail;}

}

if ($FORM{'www'} eq "http://") {$FORM{'www'} = "";}

($part1, $part2) = split(/\./, $FORM{'www'});

if ($FORM{'www'}) 
{
 if ($part1 eq "") {&wrong_url;}
 if ($part2 eq "") {&wrong_url;}
 
 if ($FORM{'www'} =~ /[\x80-\xff]/i) {&wrong_url;}
 
 $miss = 1;
 if ($FORM{'www'} =~ /^http:\/\//i) {$miss = 0;}
 if ($miss == 1) {$FORM{'www'} = "http://$FORM{'www'}";}
 
}


$ip = $ENV{'REMOTE_ADDR'};
$domain = $ENV{'REMOTE_HOST'};

# &SetCookiePath($gb_url_path);
# &SetCompressedCookies ($gb_name, 'pronet_name', $FORM{'realname'}, 'pronet_mail', $FORM{'username'}, 'pronet_www', $FORM{'www'});

# define new ID

$new_id = 0;

open(CONV, $gb_path);
 @inconv = <CONV>;
close(CONV);

foreach $conv (@inconv)
{
 ($r_id, $r_ip, $r_time, $r_name, $r_mail, $r_www, $r_text) = split(/\|/, $conv);

# Convert data file if the old format
if ($r_ip)
{
$miss = 0;
if ($r_id =~ /\D/) {$miss = 1;}
if ($miss == 1) {&convert;}

$new_id = $r_id + 1;

}



}

open (FILE,">>$gb_path") || die "Can't Open gb.txt: $!\n";
 print FILE "$new_id|$ip|dt/$c_day/$c_month/$c_year/$c_hour/$c_min|$FORM{'realname'}|$FORM{'username'}|$FORM{'www'}|$FORM{'comments'}|$domain|\n";
close(FILE);



if ($no_page)
{
print "Location: $gb_url\n\n";
exit;
}

$sub_str = $string_thanks;
$sub_title = $title_thanks;

print "Content-type: text/html\n\n";
print "<html><head><title>$sub_title - $title</title>\n";
print "$TOP";

$temp = scalar(@words);

$header =~ s/!!/$sub_title/g;
print "$header";
print "$sub_str";
print "<BR>$word_len - $w2long<BR>";
print "$BOTTOM";	
	
exit;


# Subroutines

sub no_name
{

$sub_str = $string_no_name;
$sub_title = $title_no_name;

&page;
}

sub no_comments
{

$sub_str = $string_no_comments;
$sub_title = $title_no_comments;

&page;
}

sub too_long
{

$string_too_long_comments =~ s/!!/$rec_len/g;

$sub_str = $string_too_long_comments;
$sub_title = $title_too_long_comments;

&page;

}

sub too_long_words
{

$sub_str = $string_too_long_words;
$sub_title = $title_too_long_words;

&page;

}


sub wrong_url
{

$sub_str = $string_wrong_url;
$sub_title = $title_wrong_url;

&page;

}

sub wrong_mail
{

$sub_str = $string_wrong_mail;
$sub_title = $title_wrong_mail;

&page;
	
}


sub page {

print "Content-type: text/html\n\n";
print "<html><head><title>$sub_title - $title</title>\n";
print "$TOP";

$header =~ s/!!/$sub_title/g;
print "$header";
print "$sub_str";
print "$forma\n";
print "$BOTTOM";	
	
exit;

}


sub convert
{

open(CONV, $gb_path);
@inconv = <CONV>;
close(CONV);

open(CONV, ">$gb_path");


$ct = 0;
foreach $conv (@inconv)
{

print CONV "$ct|$conv";
$ct++;

}

print "Content-type: text/html\n\n";
print "<HTML>\n";
print "<HEAD>\n<TITLE>Updated!</TITLE>\n</HEAD>\n<BODY BGCOLOR=\#FFFFFF TEXT=\#000000>\n";
print "<H1>Updated!</H1>";
print "The new version of guestbook was installed, so the data file ($gb_path) was converted to the new format.<BR>\n";
print "Please click \"Reload\" button of your browser to refresh the page.<BR>\n";
print "</BODY>\n</HTML>";
close(CONV);
exit;
}